//
// Timing
// using C++ STL generic function library
//
// Copyright (c) 1997, 1998, S. Lonardi, (stelo@cs.purdue.edu)
// May be used for research or personal use, but not for commercial
// use or as part of commercial software without written consent
// from the author.
//
// $ id = v1.1 9.20.97 $
//

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/times.h>
#include <sys/time.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>

struct timeval
  t1, t2;

struct tms
  tms1, tms2;

double second(void)
{
  return (double)clock() / (double)CLOCKS_PER_SEC;
}

void start_time() {
  int 
    n;
  n = gettimeofday(&t1, NULL);
  if (n < 0)
    perror("gettimeofday");
}

void end_time() {
  int
    n;
  double
    ms1, ms2;
  n = gettimeofday(&t2, NULL);
  if (n < 0)
    perror("gettimeofday");

  ms1 = (double)t1.tv_sec * 1000.0 + (double)t1.tv_usec / 1000.0;
  ms2 = (double)t2.tv_sec * 1000.0 + (double)t2.tv_usec / 1000.0;
  printf ("(Time of Day) Completion time %f sec\n", (ms2 - ms1) / 1000.0);
}

void start_time2() {
  int
    n;
  n = times(&tms1);
  if (n < 0)
    perror("times");
}

void end_time2() {
  int
    n;
  double
    ms1, ms2;
  n = times(&tms2);
  if (n < 0)
    perror("gettimeofday");

  ms1 = ((double)tms2.tms_utime - (double)tms1.tms_utime) / CLK_TCK;
  ms2 = ((double)tms2.tms_stime - (double)tms1.tms_stime) / CLK_TCK;
  printf ("Completion time %f sec\n", ms1+ms2);
  printf ("                %f min\n", (ms1+ms2)/60.0);
}
