//
// Off-Line decompressor
// uses C++ STL generic function library
//
// Copyright (c) 1997, 1998, S. Lonardi, (stelo@cs.purdue.edu)
// May be used for research or personal use, but not for commercial
// use or as part of commercial software without written consent
// from the author.
//
// $ id = v2.0 10.28.98 $
//

#include <assert.h>
#include <fstream.h>
//#include "bstring.h"
#include <vector.h>
#include <stack.h>
#include <list.h>
#include <algo.h>
#include <math.h>
#include "st.h"
#include "zlibengn.h"

#define MIN_OCC    2   // consider only matchs whose occurreces is >= MIN_OCC
#define MIN_LENGTH 2   // consider only matchs >= MIN_LENGTH

//#define GRAMMAR
//#define DEBUGSTAT
//#define DEBUG
//#define VERBOSE // print all the step performed
//#define PREFIX

#define MAXSHORT 65535
#define MAXCHAR  255
#define TOTAL    256

extern double second (void);
extern void start_time (void);
extern void end_time (void);
extern void start_time2 (void);
extern void end_time2 (void);

char_vector vec(char *s) {
  //
  // transform a string in a <vector>
  //
  char_vector x;
  while (*s != '\0') 
    x.push_back(*s++);
  return x;
  // end vec
}


void print_vec (char_vector& x) {
  //
  // print a vector<char> in numbers
  //
  for (char_vector_iterator i = x.begin(); i != x.end(); ++i)
    cout << " " << (unsigned short)(*i & 0xFF);
  // end print_vec
}


void print_vec_char (char_vector& x) {
  //
  // print a vector<char> in chars
  //
  for (char_vector_iterator i = x.begin(); i != x.end(); ++i)
    cout << *i;
  // end print_vec_char
}


main(int argc, char* argv[]) {
  string
    file_name = ".in";
  char_vector
    text,
    sublen_vec,
    substr_vec,
    occurr_vec,
    abspol_vec,
    abspoh_vec,
    relpol_vec,
    relpoh_vec,
    prefix_vec;
  ZlibEngine
    eng;

  //
  // load the plain encoding
  //
  if (argc == 2)
     file_name = argv[1];

  file_name += ".off";

  ifstream
    ifs(file_name.c_str());

  if (!ifs) {
    cout << "Couldn't open the input file" << endl;
    exit(0);
  }

# ifdef VERBOSE
  cout << "Reading file" << endl;
# endif
  //
  // load the lengths of the arrays
  //
  unsigned char
    c1,
    c2;
  int
    v1_size,
    v2_size,
    v3_size,
    v4_size,
    v5_size,
    v6_size,
    v7_size,
#   ifdef PREFIX
    v9_size,
#   endif
    v8_size;

  ifs.get(c1);
  ifs.get(c2);
  v1_size = (int)c1 + (int)c2 * 256;
  ifs.get(c1);
  ifs.get(c2);
  v2_size = (int)c1 + (int)c2 * 256;
  ifs.get(c1);
  ifs.get(c2);
  v3_size = (int)c1 + (int)c2 * 256;
  ifs.get(c1);
  ifs.get(c2);
  v4_size = (int)c1 + (int)c2 * 256;
  ifs.get(c1);
  ifs.get(c2);
  v5_size = (int)c1 + (int)c2 * 256;
  ifs.get(c1);
  ifs.get(c2);
  v6_size = (int)c1 + (int)c2 * 256;
  ifs.get(c1);
  ifs.get(c2);
  v7_size = (int)c1 + (int)c2 * 256;
  ifs.get(c1);
  ifs.get(c2);
  v8_size = (int)c1 + (int)c2 * 256;
# ifdef PREFIX
  ifs.get(c1);
  ifs.get(c2);
  v9_size = (int)c1 + (int)c2 * 256;
# endif

# ifdef DEBUG_DEC 
  cout << v1_size << endl; 
  cout << v2_size << endl; 
  cout << v3_size << endl; 
  cout << v4_size << endl; 
  cout << v5_size << endl; 
  cout << v6_size << endl; 
  cout << v7_size << endl; 
  cout << v8_size << endl; 
# ifdef PREFIX
  cout << v9_size << endl; 
# endif
# endif
  //
  // load the data of the arrays
  //
  unsigned char
    c;
  for (int i = 0; i < v1_size; i++) {
    ifs.get(c);
    if (ifs)
      text.push_back(c);
  }

  for (int i = 0; i < v2_size; i++) {
    ifs.get(c);
    if (ifs)
      sublen_vec.push_back(c);
  }

  for (int i = 0; i < v3_size; i++) {
    ifs.get(c);
    if (ifs)
      substr_vec.push_back(c);
  }

  for (int i = 0; i < v4_size; i++) {
    ifs.get(c);
    if (ifs)
      occurr_vec.push_back(c);
  }

  for (int i = 0; i < v5_size; i++) {
    ifs.get(c);
    if (ifs)
      abspol_vec.push_back(c);
  }

  for (int i = 0; i < v6_size; i++) {
    ifs.get(c);
    if (ifs)
      abspoh_vec.push_back(c);
  }

  for (int i = 0; i < v7_size; i++) {
    ifs.get(c);
    if (ifs)
      relpol_vec.push_back(c);
  }

  for (int i = 0; i < v8_size; i++) {
    ifs.get(c);
    if (ifs)
      relpoh_vec.push_back(c);
  }

# ifdef PREFIX
  for (int i = 0; i < v9_size; i++) {
    ifs.get(c);
    if (ifs)
      prefix_vec.push_back(c);
  }
# endif
  ifs.close();

  cout << "text = [";
  print_vec_char(text);
  cout << "] (size " << text.size() << ")" << endl << endl;
  cout << "sublen = [";
  print_vec (sublen_vec);
  cout << "] (size " << sublen_vec.size() << ")" << endl << endl;
  cout << "substr = [";
  print_vec_char(substr_vec);
  cout << "] (size " << substr_vec.size() << ")" << endl << endl;
  cout << "occurr = [";
  print_vec (occurr_vec);
  cout << "] (size " << occurr_vec.size() << ")" << endl << endl;
  cout << "abspol = [";
  print_vec (abspol_vec);
  cout << "] (size " << abspol_vec.size() << ")" << endl << endl;
  cout << "abspoh = [";
  print_vec (abspoh_vec);
  cout << "] (size " << abspoh_vec.size() << ")" << endl << endl;
  cout << "relpol = [";
  print_vec (relpol_vec);
  cout << "] (size " << relpol_vec.size() << ")" << endl << endl;
  cout << "relpoh = [";
  print_vec (relpoh_vec);
  cout << "] (size " << relpoh_vec.size() << ")" << endl << endl;

# ifdef PREFIX
  cout << "prefix = [";
  print_vec(prefix_vec);
  cout << "] (size " << prefix_vec.size() << ")" << endl << endl;
# endif

   //
  // Decompressing text, using sublen, substr, relpo[l|h], abspo[l|h]
  //
  char_vector_iterator
    sub = substr_vec.end(),
    occ = occurr_vec.end() - 1,
    abl = abspol_vec.end() - 1,
    abh = abspoh_vec.end() - 1,
    rel,
    reh,
    oldrel = relpol_vec.end(),
    oldreh = relpoh_vec.end();
  int
#   ifdef GRAMMAR
    prod = 0,
#   endif
    pos;
  unsigned short
    abl_,
    abh_,
    rel_,
    reh_,
    sbl_,
    occ_;

# ifdef DEBUG_DEC 
  cout << "Text: ";
  print_vec_char(text);
  cout << endl;
# endif
  for (char_vector_iterator sbl = sublen_vec.end() - 1;
       sbl != (sublen_vec.begin() - 1); --sbl, --occ, --abl, --abh) {
    abl_ = (unsigned short)(*abl & 0xFF);
    abh_ = (unsigned short)(*abh & 0xFF);
    sbl_ = (unsigned short)(*sbl & 0xFF);
    occ_ = (unsigned short)(*occ & 0xFF);
#   ifdef DEBUG_DEC 
    cout << "Occurrences: " << occ_ << endl;
#   endif
    while (occ_ == MAXCHAR) {
      occ--;
      occ_ += (unsigned short)(*occ & 0xFF);
    }
    occ_ += MIN_OCC;
    while (sbl_ == MAXCHAR) {
      sbl--;
      sbl_ += (unsigned short)(*sbl & 0xFF);
    }
    sbl_ += MIN_LENGTH;
    //
    // insert in the first absolute pos (MAXCHAR to do!)
    //
    pos = abl_ + abh_ * MAXCHAR; // 1st position
    sub -= sbl_;
#   ifdef DEBUG_DEC 
    cout << "Insert in position: " << pos << " len " << sbl_ << endl;
#   endif

#   ifdef GRAMMAR
    char_vector
      pr;
    pr.push_back('<');
    for (int k = 0; k < (sbl_ - 2); k++)
      pr.push_back('A'+prod);
    pr.push_back('>');
    text.insert(text.begin() + pos, pr.begin(), pr.end());
    prod++;
    char_vector
      lh(sub, sub + sbl_); 
    cout << pr << " -> \"" << lh << "\"" << endl;
#   else
    text.insert(text.begin() + pos, sub, sub + sbl_);
#   endif

#   ifdef DEBUG_DEC 
    cout << "Text: "; 
    print_vec_char(text);
    cout << endl;
#   endif
    rel = oldrel - occ_ + 1;
    reh = oldreh - occ_ + 1;
    oldrel = rel;
    oldreh = reh;
    //
    // insert the other relative pos (MAXCHAR to do!)
    //
    for (int i = 1; i < occ_; i++, ++rel, ++reh) {
      rel_ = (unsigned short)(*rel & 0xFF);
      reh_ = (unsigned short)(*reh & 0xFF);
#     ifdef DEBUG_DEC 
      cout << "rel = " << rel_ << endl;
      cout << "reh = " << reh_ << endl;
#     endif
      pos += sbl_ + rel_ + reh_ * MAXCHAR; // other positions
#     ifdef DEBUG_DEC 
      cout << "Insert in position: " << pos << " len " << sbl_ << endl;
#     endif
#     ifdef GRAMMAR
      text.insert(text.begin() + pos, pr.begin(), pr.end());
#     else
      text.insert(text.begin() + pos, sub, sub + sbl_);
#     endif
#     ifdef DEBUG_DEC 
      cout << "Text: ";
      print_vec_char(text);
      cout << endl;
#     endif
    }
  }

  cout << endl << " --- Decoded text --- " << endl;
  print_vec_char(text);
  cout << endl;
}
